/* cc -O2 -o iceII iceII.c -lm

ice II (no proton disorder)
Fortes_PhD_thesis
J. Chem. Phys., Vol. 117, No. 8, 22 August 2002 (?)
 */
#include "../gen/include.h"
#include "../gen/rndgeni.c"
typedef float real;
#include "../gen/vector3d.h"

vector axes[3]={
  {7.3124993,-1.8782643,-1.8782643},
  {-1.8782643,7.3124993,-1.8782643},
  {-1.8782643,-1.8782643,7.3124993}
};

/* in axes: */
vector atoms[6]={
  { 0.0204, 0.8513, 0.2681},
  { 0.0416, 0.7924, 0.1447},
  { 0.1929, 0.9853, 0.4221},

  { 0.5225, 0.2516, 0.6707},
  { 0.5902, 0.2686, 0.5914},
  { 0.6247, 0.2537, 0.7938}
};


int main(int narg,char **arg)
{
  int i,j,k,ii,sym,n,h;
  int nsym=6;
  float r[3];
  FILE *plb;
  vector p;

  VECT(p,axes[0],axes[1])
  printf("V=%g\n",SCAL(p,axes[2]));

  if (narg<2) {
    fprintf(stderr,"Call by:\n\
  iceII ncell\n");
    exit(0); }

  n=atoi(arg[1]);

  plb=fopen("iceII.plb","wb");

  r[0]=6*Cub(2*n+1)*nsym;
  r[1]=-3;
  fwrite(r,2,4,plb);

  r[0]=r[1]=r[2]=n*10;
  fwrite(r,3,4,plb);

  loopto (i,-n,n)
    loopto (j,-n,n)
      loopto (k,-n,n)
        loop (sym,0,nsym) {
           loop (ii,0,6) {
             VO(atoms[ii],*=-1)
             if (sym&1) {
               double x=atoms[ii][0];
               atoms[ii][0]=atoms[ii][1];
               atoms[ii][1]=atoms[ii][2];
               atoms[ii][2]=x; }

             r[0]=(atoms[ii][0]+i)*axes[0][0]+(atoms[ii][1]+j)*axes[1][0]+(atoms[ii][2]+k)*axes[2][0];
             r[1]=(atoms[ii][0]+i)*axes[0][1]+(atoms[ii][1]+j)*axes[1][1]+(atoms[ii][2]+k)*axes[2][1];
             r[2]=(atoms[ii][0]+i)*axes[0][2]+(atoms[ii][1]+j)*axes[1][2]+(atoms[ii][2]+k)*axes[2][2];

             fwrite(r,3,4,plb); } }
  
  fclose(plb);

  return 0;
}
/*
RESULTS: 
Lx=12.998
Ly=22.513
Lz=6.15911
plbbox  iceIIzsel.0000.plb =12.998 =22.513 =6.159
plbshift  iceIIzsel.0000.plb  iceIIhexcell.plb 0.1 0 0 3




OLD:
iceIIhex.plb:
lb= -3.99745   4.00049 
rt=  9.0164   11.5422   
L=13.0138    7.5417   5.7887739
zdif=1.9295913*n
V=283.536 (12 rhomb)
Vhex= 189.38201*n, needs n=3
*/

